#include "../../pmu-events/pmu-events.h"
struct pmu_event pme_cavium_thunderx2[] = {
{
	.name = "l1d_cache_rd",
	.event = "event=0x40",
	.desc = "L1D cache access, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache access, read",
},
{
	.name = "l1d_cache_wr",
	.event = "event=0x41",
	.desc = "L1D cache access, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache access, write",
},
{
	.name = "l1d_cache_refill_rd",
	.event = "event=0x42",
	.desc = "L1D cache refill, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache refill, read",
},
{
	.name = "l1d_cache_refill_wr",
	.event = "event=0x43",
	.desc = "L1D cache refill, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache refill, write",
},
{
	.name = "l1d_cache_refill_inner",
	.event = "event=0x44",
	.desc = "L1D cache refill, inner",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache refill, inner",
},
{
	.name = "l1d_cache_refill_outer",
	.event = "event=0x45",
	.desc = "L1D cache refill, outer",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache refill, outer",
},
{
	.name = "l1d_cache_wb_victim",
	.event = "event=0x46",
	.desc = "L1D cache Write-Back, victim",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache Write-Back, victim",
},
{
	.name = "l1d_cache_wb_clean",
	.event = "event=0x47",
	.desc = "L1D cache Write-Back, cleaning and coherency",
	.topic = "core imp def",
	.long_desc = "Level 1 data cache Write-Back, cleaning and coherency",
},
{
	.name = "l1d_cache_inval",
	.event = "event=0x48",
	.desc = "L1D cache invalidate",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache invalidate",
},
{
	.name = "l1d_tlb_refill_rd",
	.event = "event=0x4c",
	.desc = "L1D tlb refill, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data TLB refill, read",
},
{
	.name = "l1d_tlb_refill_wr",
	.event = "event=0x4d",
	.desc = "L1D tlb refill, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data TLB refill, write",
},
{
	.name = "l1d_tlb_rd",
	.event = "event=0x4e",
	.desc = "L1D tlb access, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data or unified TLB access, read",
},
{
	.name = "l1d_tlb_wr",
	.event = "event=0x4f",
	.desc = "L1D tlb access, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data or unified TLB access, write",
},
{
	.name = "l2d_tlb_refill_rd",
	.event = "event=0x5c",
	.desc = "L2D cache refill, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data or unified TLB refill, read",
},
{
	.name = "l2d_tlb_refill_wr",
	.event = "event=0x5d",
	.desc = "L2D cache refill, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data or unified TLB refill, write",
},
{
	.name = "l2d_tlb_rd",
	.event = "event=0x5e",
	.desc = "L2D cache access, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data or unified TLB access, read",
},
{
	.name = "l2d_tlb_wr",
	.event = "event=0x5f",
	.desc = "L2D cache access, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data or unified TLB access, write",
},
{
	.name = "bus_access_rd",
	.event = "event=0x60",
	.desc = "Bus access read",
	.topic = "core imp def",
	.long_desc = "Bus access read",
},
{
	.name = "bus_access_wr",
	.event = "event=0x61",
	.desc = "Bus access write",
	.topic = "core imp def",
	.long_desc = "Bus access write",
},
{
	.name = "mem_access_rd",
	.event = "event=0x66",
	.desc = "Data memory access, read",
	.topic = "core imp def",
	.long_desc = "Data memory access, read",
},
{
	.name = "mem_access_wr",
	.event = "event=0x67",
	.desc = "Data memory access, write",
	.topic = "core imp def",
	.long_desc = "Data memory access, write",
},
{
	.name = "unaligned_ld_spec",
	.event = "event=0x68",
	.desc = "Unaligned access, read",
	.topic = "core imp def",
	.long_desc = "Unaligned access, read",
},
{
	.name = "unaligned_st_spec",
	.event = "event=0x69",
	.desc = "Unaligned access, write",
	.topic = "core imp def",
	.long_desc = "Unaligned access, write",
},
{
	.name = "unaligned_ldst_spec",
	.event = "event=0x6a",
	.desc = "Unaligned access",
	.topic = "core imp def",
	.long_desc = "Unaligned access",
},
{
	.name = "exc_undef",
	.event = "event=0x81",
	.desc = "Exception taken, Other synchronous",
	.topic = "core imp def",
	.long_desc = "Exception taken, Other synchronous",
},
{
	.name = "exc_svc",
	.event = "event=0x82",
	.desc = "Exception taken, Supervisor Call",
	.topic = "core imp def",
	.long_desc = "Exception taken, Supervisor Call",
},
{
	.name = "exc_pabort",
	.event = "event=0x83",
	.desc = "Exception taken, Instruction Abort",
	.topic = "core imp def",
	.long_desc = "Exception taken, Instruction Abort",
},
{
	.name = "exc_dabort",
	.event = "event=0x84",
	.desc = "Exception taken, Data Abort and SError",
	.topic = "core imp def",
	.long_desc = "Exception taken, Data Abort and SError",
},
{
	.name = "exc_irq",
	.event = "event=0x86",
	.desc = "Exception taken, IRQ",
	.topic = "core imp def",
	.long_desc = "Exception taken, IRQ",
},
{
	.name = "exc_fiq",
	.event = "event=0x87",
	.desc = "Exception taken, FIQ",
	.topic = "core imp def",
	.long_desc = "Exception taken, FIQ",
},
{
	.name = "exc_smc",
	.event = "event=0x88",
	.desc = "Exception taken, Secure Monitor Call",
	.topic = "core imp def",
	.long_desc = "Exception taken, Secure Monitor Call",
},
{
	.name = "exc_hvc",
	.event = "event=0x8a",
	.desc = "Exception taken, Hypervisor Call",
	.topic = "core imp def",
	.long_desc = "Exception taken, Hypervisor Call",
},
{
	.name = "exc_trap_pabort",
	.event = "event=0x8b",
	.desc = "Exception taken, Instruction Abort not taken locally",
	.topic = "core imp def",
	.long_desc = "Exception taken, Instruction Abort not taken locally",
},
{
	.name = "exc_trap_dabort",
	.event = "event=0x8c",
	.desc = "Exception taken, Data Abort or SError not taken locally",
	.topic = "core imp def",
	.long_desc = "Exception taken, Data Abort or SError not taken locally",
},
{
	.name = "exc_trap_other",
	.event = "event=0x8d",
	.desc = "Exception taken, Other traps not taken locally",
	.topic = "core imp def",
	.long_desc = "Exception taken, Other traps not taken locally",
},
{
	.name = "exc_trap_irq",
	.event = "event=0x8e",
	.desc = "Exception taken, IRQ not taken locally",
	.topic = "core imp def",
	.long_desc = "Exception taken, IRQ not taken locally",
},
{
	.name = "exc_trap_fiq",
	.event = "event=0x8f",
	.desc = "Exception taken, FIQ not taken locally",
	.topic = "core imp def",
	.long_desc = "Exception taken, FIQ not taken locally",
},
{
	.name = 0,
	.event = 0,
	.desc = 0,
},
};
struct pmu_event pme_ampere_emag[] = {
{
	.name = "l1d_cache_rd",
	.event = "event=0x40",
	.desc = "L1D cache access, read",
	.topic = "cache",
	.long_desc = "Attributable Level 1 data cache access, read",
},
{
	.name = "l1d_cache_wr",
	.event = "event=0x41",
	.desc = "L1D cache access, write",
	.topic = "cache",
	.long_desc = "Attributable Level 1 data cache access, write",
},
{
	.name = "l1d_cache_refill_rd",
	.event = "event=0x42",
	.desc = "L1D cache refill, read",
	.topic = "cache",
	.long_desc = "Attributable Level 1 data cache refill, read",
},
{
	.name = "l1d_cache_inval",
	.event = "event=0x48",
	.desc = "L1D cache invalidate",
	.topic = "cache",
	.long_desc = "Attributable Level 1 data cache invalidate",
},
{
	.name = "l1d_tlb_refill_rd",
	.event = "event=0x4c",
	.desc = "L1D tlb refill, read",
	.topic = "cache",
	.long_desc = "Attributable Level 1 data TLB refill, read",
},
{
	.name = "l1d_tlb_refill_wr",
	.event = "event=0x4d",
	.desc = "L1D tlb refill, write",
	.topic = "cache",
	.long_desc = "Attributable Level 1 data TLB refill, write",
},
{
	.name = "l2d_cache_rd",
	.event = "event=0x50",
	.desc = "L2D cache access, read",
	.topic = "cache",
	.long_desc = "Attributable Level 2 data cache access, read",
},
{
	.name = "l2d_cache_wr",
	.event = "event=0x51",
	.desc = "L2D cache access, write",
	.topic = "cache",
	.long_desc = "Attributable Level 2 data cache access, write",
},
{
	.name = "l2d_cache_refill_rd",
	.event = "event=0x52",
	.desc = "L2D cache refill, read",
	.topic = "cache",
	.long_desc = "Attributable Level 2 data cache refill, read",
},
{
	.name = "l2d_cache_refill_wr",
	.event = "event=0x53",
	.desc = "L2D cache refill, write",
	.topic = "cache",
	.long_desc = "Attributable Level 2 data cache refill, write",
},
{
	.name = "l2d_cache_wb_victim",
	.event = "event=0x56",
	.desc = "L2D cache Write-Back, victim",
	.topic = "cache",
	.long_desc = "Attributable Level 2 data cache Write-Back, victim",
},
{
	.name = "l2d_cache_wb_clean",
	.event = "event=0x57",
	.desc = "L2D cache Write-Back, cleaning and coherency",
	.topic = "cache",
	.long_desc = "Level 2 data cache Write-Back, cleaning and coherency",
},
{
	.name = "l2d_cache_inval",
	.event = "event=0x58",
	.desc = "L2D cache invalidate",
	.topic = "cache",
	.long_desc = "Attributable Level 2 data cache invalidate",
},
{
	.name = "l1i_cache_refill",
	.event = "event=0x1",
	.desc = "L1I cache refill",
	.topic = "cache",
	.long_desc = "Level 1 instruction cache refill",
},
{
	.name = "l1i_tlb_refill",
	.event = "event=0x2",
	.desc = "L1I TLB refill",
	.topic = "cache",
	.long_desc = "Level 1 instruction TLB refill",
},
{
	.name = "l1d_cache_refill",
	.event = "event=0x3",
	.desc = "L1D cache refill",
	.topic = "cache",
	.long_desc = "Level 1 data cache refill",
},
{
	.name = "l1d_cache_access",
	.event = "event=0x4",
	.desc = "L1D cache access",
	.topic = "cache",
	.long_desc = "Level 1 data cache access",
},
{
	.name = "l1d_tlb_refill",
	.event = "event=0x5",
	.desc = "L1D TLB refill",
	.topic = "cache",
	.long_desc = "Level 1 data TLB refill",
},
{
	.name = "l1i_cache_access",
	.event = "event=0x14",
	.desc = "L1I cache access",
	.topic = "cache",
	.long_desc = "Level 1 instruction cache access",
},
{
	.name = "l2d_cache_access",
	.event = "event=0x16",
	.desc = "L2D cache access",
	.topic = "cache",
	.long_desc = "Level 2 data cache access",
},
{
	.name = "l2d_cache_refill",
	.event = "event=0x17",
	.desc = "L2D cache refill",
	.topic = "cache",
	.long_desc = "Level 2 data refill",
},
{
	.name = "l2d_cache_wb",
	.event = "event=0x18",
	.desc = "L2D cache Write-Back",
	.topic = "cache",
	.long_desc = "Level 2 data cache, Write-Back",
},
{
	.name = "l1d_tlb_access",
	.event = "event=0x25",
	.desc = "L1D TLB access",
	.topic = "cache",
	.long_desc = "Level 1 data TLB access. This event counts any load or store operation which accesses the data L1 TLB",
},
{
	.name = "l1i_tlb_access",
	.event = "event=0x26",
	.desc = "L1I TLB access",
	.topic = "cache",
	.long_desc = "Level 1 instruction TLB access. This event counts any instruction fetch which accesses the instruction L1 TLB",
},
{
	.name = "l2d_tlb_access",
	.event = "event=0x34",
	.desc = "L2D TLB access",
	.topic = "cache",
	.long_desc = "Level 2 access to data TLB that caused a page table walk. This event counts on any data access which causes L2D_TLB_REFILL to count",
},
{
	.name = "l2i_tlb_access",
	.event = "event=0x35",
	.desc = "L2D TLB access",
	.topic = "cache",
	.long_desc = "Level 2 access to instruciton TLB that caused a page table walk. This event counts on any instruciton access which causes L2I_TLB_REFILL to count",
},
{
	.name = "btb_mis_pred",
	.event = "event=0x102",
	.desc = "BTB misprediction",
	.topic = "cache",
	.long_desc = "Branch target buffer misprediction",
},
{
	.name = "itb_miss",
	.event = "event=0x103",
	.desc = "ITB miss",
	.topic = "cache",
	.long_desc = "ITB miss",
},
{
	.name = "dtb_miss",
	.event = "event=0x104",
	.desc = "DTB miss",
	.topic = "cache",
	.long_desc = "DTB miss",
},
{
	.name = "l1d_cache_late_miss",
	.event = "event=0x105",
	.desc = "L1D cache late miss",
	.topic = "cache",
	.long_desc = "Level 1 data cache late miss",
},
{
	.name = "l1d_cache_prefetch",
	.event = "event=0x106",
	.desc = "L1D cache prefetch",
	.topic = "cache",
	.long_desc = "Level 1 data cache prefetch request",
},
{
	.name = "l2d_cache_prefetch",
	.event = "event=0x107",
	.desc = "L2D cache prefetch",
	.topic = "cache",
	.long_desc = "Level 2 data cache prefetch request",
},
{
	.name = "l1_stage2_tlb_refill",
	.event = "event=0x111",
	.desc = "L1 stage 2 TLB refill",
	.topic = "cache",
	.long_desc = "Level 1 stage 2 TLB refill",
},
{
	.name = "page_walk_l0_stage1_hit",
	.event = "event=0x112",
	.desc = "Page walk, L0 stage-1 hit",
	.topic = "cache",
	.long_desc = "Page walk cache level-0 stage-1 hit",
},
{
	.name = "page_walk_l1_stage1_hit",
	.event = "event=0x113",
	.desc = "Page walk, L1 stage-1 hit",
	.topic = "cache",
	.long_desc = "Page walk cache level-1 stage-1 hit",
},
{
	.name = "page_walk_l2_stage1_hit",
	.event = "event=0x114",
	.desc = "Page walk, L2 stage-1 hit",
	.topic = "cache",
	.long_desc = "Page walk cache level-2 stage-1 hit",
},
{
	.name = "page_walk_l1_stage2_hit",
	.event = "event=0x115",
	.desc = "Page walk, L1 stage-2 hit",
	.topic = "cache",
	.long_desc = "Page walk cache level-1 stage-2 hit",
},
{
	.name = "page_walk_l2_stage2_hit",
	.event = "event=0x116",
	.desc = "Page walk, L2 stage-2 hit",
	.topic = "cache",
	.long_desc = "Page walk cache level-2 stage-2 hit",
},
{
	.name = "cpu_cycles",
	.event = "event=0x11",
	.desc = "Clock cycles",
	.topic = "clock",
	.long_desc = "The number of core clock cycles",
},
{
	.name = "fsu_clock_off_cycles",
	.event = "event=0x101",
	.desc = "FSU clocking gated off cycle",
	.topic = "clock",
	.long_desc = "FSU clocking gated off cycle",
},
{
	.name = "wait_cycles",
	.event = "event=0x110",
	.desc = "Wait state cycle",
	.topic = "clock",
	.long_desc = "Wait state cycle",
},
{
	.name = "exc_undef",
	.event = "event=0x81",
	.desc = "Exception taken, Other synchronous",
	.topic = "exception",
	.long_desc = "Exception taken, Other synchronous",
},
{
	.name = "exc_svc",
	.event = "event=0x82",
	.desc = "Exception taken, Supervisor Call",
	.topic = "exception",
	.long_desc = "Exception taken, Supervisor Call",
},
{
	.name = "exc_pabort",
	.event = "event=0x83",
	.desc = "Exception taken, Instruction Abort",
	.topic = "exception",
	.long_desc = "Exception taken, Instruction Abort",
},
{
	.name = "exc_dabort",
	.event = "event=0x84",
	.desc = "Exception taken, Data Abort and SError",
	.topic = "exception",
	.long_desc = "Exception taken, Data Abort and SError",
},
{
	.name = "exc_irq",
	.event = "event=0x86",
	.desc = "Exception taken, IRQ",
	.topic = "exception",
	.long_desc = "Exception taken, IRQ",
},
{
	.name = "exc_fiq",
	.event = "event=0x87",
	.desc = "Exception taken, FIQ",
	.topic = "exception",
	.long_desc = "Exception taken, FIQ",
},
{
	.name = "exc_hvc",
	.event = "event=0x8a",
	.desc = "Exception taken, Hypervisor Call",
	.topic = "exception",
	.long_desc = "Exception taken, Hypervisor Call",
},
{
	.name = "exc_trap_pabort",
	.event = "event=0x8b",
	.desc = "Exception taken, Instruction Abort not taken locally",
	.topic = "exception",
	.long_desc = "Exception taken, Instruction Abort not taken locally",
},
{
	.name = "exc_trap_dabort",
	.event = "event=0x8c",
	.desc = "Exception taken, Data Abort or SError not taken locally",
	.topic = "exception",
	.long_desc = "Exception taken, Data Abort or SError not taken locally",
},
{
	.name = "exc_trap_other",
	.event = "event=0x8d",
	.desc = "Exception taken, Other traps not taken locally",
	.topic = "exception",
	.long_desc = "Exception taken, Other traps not taken locally",
},
{
	.name = "exc_trap_irq",
	.event = "event=0x8e",
	.desc = "Exception taken, IRQ not taken locally",
	.topic = "exception",
	.long_desc = "Exception taken, IRQ not taken locally",
},
{
	.name = "exc_trap_fiq",
	.event = "event=0x8f",
	.desc = "Exception taken, FIQ not taken locally",
	.topic = "exception",
	.long_desc = "Exception taken, FIQ not taken locally",
},
{
	.name = "exc_taken",
	.event = "event=0x9",
	.desc = "Exception taken",
	.topic = "exception",
	.long_desc = "Exception taken",
},
{
	.name = "exc_return",
	.event = "event=0xa",
	.desc = "Exception return",
	.topic = "exception",
	.long_desc = "Instruction architecturally executed, condition check pass, exception return",
},
{
	.name = "decode_stall",
	.event = "event=0x108",
	.desc = "Decode starved",
	.topic = "pipeline",
	.long_desc = "Decode starved for instruction cycle",
},
{
	.name = "dispatch_stall",
	.event = "event=0x109",
	.desc = "Dispatch stalled",
	.topic = "pipeline",
	.long_desc = "Op dispatch stalled cycle",
},
{
	.name = "ixa_stall",
	.event = "event=0x10a",
	.desc = "IXA stalled",
	.topic = "pipeline",
	.long_desc = "IXA Op non-issue",
},
{
	.name = "ixb_stall",
	.event = "event=0x10b",
	.desc = "IXB stalled",
	.topic = "pipeline",
	.long_desc = "IXB Op non-issue",
},
{
	.name = "bx_stall",
	.event = "event=0x10c",
	.desc = "BX stalled",
	.topic = "pipeline",
	.long_desc = "BX Op non-issue",
},
{
	.name = "lx_stall",
	.event = "event=0x10d",
	.desc = "LX stalled",
	.topic = "pipeline",
	.long_desc = "LX Op non-issue",
},
{
	.name = "sx_stall",
	.event = "event=0x10e",
	.desc = "SX stalled",
	.topic = "pipeline",
	.long_desc = "SX Op non-issue",
},
{
	.name = "fx_stall",
	.event = "event=0x10f",
	.desc = "FX stalled",
	.topic = "pipeline",
	.long_desc = "FX Op non-issue",
},
{
	.name = "bus_access_rd",
	.event = "event=0x60",
	.desc = "Bus access read",
	.topic = "bus",
	.long_desc = "Bus access read",
},
{
	.name = "bus_access_wr",
	.event = "event=0x61",
	.desc = "Bus access write",
	.topic = "bus",
	.long_desc = "Bus access write",
},
{
	.name = "bus_access_shared",
	.event = "event=0x62",
	.desc = "Bus access, Normal, Cacheable, Shareable",
	.topic = "bus",
	.long_desc = "Bus access, Normal, Cacheable, Shareable",
},
{
	.name = "bus_access_not_shared",
	.event = "event=0x63",
	.desc = "Bus access, not Normal, Cacheable, Shareable",
	.topic = "bus",
	.long_desc = "Bus access, not Normal, Cacheable, Shareable",
},
{
	.name = "bus_access_normal",
	.event = "event=0x64",
	.desc = "Bus access, Normal",
	.topic = "bus",
	.long_desc = "Bus access, Normal",
},
{
	.name = "bus_access_periph",
	.event = "event=0x65",
	.desc = "Bus access, peripheral",
	.topic = "bus",
	.long_desc = "Bus access, peripheral",
},
{
	.name = "bus_access",
	.event = "event=0x19",
	.desc = "Bus access",
	.topic = "bus",
	.long_desc = "Bus access",
},
{
	.name = "ldrex_spec",
	.event = "event=0x6c",
	.desc = "Exclusive operation speculatively executed, LDREX or LDX",
	.topic = "intrinsic",
	.long_desc = "Exclusive operation speculatively executed, LDREX or LDX",
},
{
	.name = "strex_pass_spec",
	.event = "event=0x6d",
	.desc = "Exclusive operation speculatively executed, STREX or STX pass",
	.topic = "intrinsic",
	.long_desc = "Exclusive operation speculatively executed, STREX or STX pass",
},
{
	.name = "strex_fail_spec",
	.event = "event=0x6e",
	.desc = "Exclusive operation speculatively executed, STREX or STX fail",
	.topic = "intrinsic",
	.long_desc = "Exclusive operation speculatively executed, STREX or STX fail",
},
{
	.name = "strex_spec",
	.event = "event=0x6f",
	.desc = "Exclusive operation speculatively executed, STREX or STX",
	.topic = "intrinsic",
	.long_desc = "Exclusive operation speculatively executed, STREX or STX",
},
{
	.name = "ld_spec",
	.event = "event=0x70",
	.desc = "Operation speculatively executed, load",
	.topic = "instruction",
	.long_desc = "Operation speculatively executed, load",
},
{
	.name = "st_spec",
	.event = "event=0x71",
	.desc = "Operation speculatively executed, store",
	.topic = "instruction",
	.long_desc = "Operation speculatively executed, store",
},
{
	.name = "ldst_spec",
	.event = "event=0x72",
	.desc = "Operation speculatively executed, load or store",
	.topic = "instruction",
	.long_desc = "Operation speculatively executed, load or store",
},
{
	.name = "dp_spec",
	.event = "event=0x73",
	.desc = "Operation speculatively executed, integer data processing",
	.topic = "instruction",
	.long_desc = "Operation speculatively executed, integer data processing",
},
{
	.name = "ase_spec",
	.event = "event=0x74",
	.desc = "Operation speculatively executed, Advanced SIMD instruction",
	.topic = "instruction",
	.long_desc = "Operation speculatively executed, Advanced SIMD instruction",
},
{
	.name = "vfp_spec",
	.event = "event=0x75",
	.desc = "Operation speculatively executed, floating-point instruction",
	.topic = "instruction",
	.long_desc = "Operation speculatively executed, floating-point instruction",
},
{
	.name = "pc_write_spec",
	.event = "event=0x76",
	.desc = "Operation speculatively executed, software change of the PC",
	.topic = "instruction",
	.long_desc = "Operation speculatively executed, software change of the PC",
},
{
	.name = "crypto_spec",
	.event = "event=0x77",
	.desc = "Operation speculatively executed, Cryptographic instruction",
	.topic = "instruction",
	.long_desc = "Operation speculatively executed, Cryptographic instruction",
},
{
	.name = "isb_spec",
	.event = "event=0x7c",
	.desc = "Barrier speculatively executed, ISB",
	.topic = "instruction",
	.long_desc = "Barrier speculatively executed, ISB",
},
{
	.name = "dsb_spec",
	.event = "event=0x7d",
	.desc = "Barrier speculatively executed, DSB",
	.topic = "instruction",
	.long_desc = "Barrier speculatively executed, DSB",
},
{
	.name = "dmb_spec",
	.event = "event=0x7e",
	.desc = "Barrier speculatively executed, DMB",
	.topic = "instruction",
	.long_desc = "Barrier speculatively executed, DMB",
},
{
	.name = "rc_ld_spec",
	.event = "event=0x90",
	.desc = "Release consistency operation speculatively executed, Load-Acquire",
	.topic = "instruction",
	.long_desc = "Release consistency operation speculatively executed, Load-Acquire",
},
{
	.name = "rc_st_spec",
	.event = "event=0x91",
	.desc = "Release consistency operation speculatively executed, Store-Release",
	.topic = "instruction",
	.long_desc = "Release consistency operation speculatively executed, Store-Release",
},
{
	.name = "sw_incr",
	.event = "event=0",
	.desc = "Software increment",
	.topic = "instruction",
	.long_desc = "Instruction architecturally executed, software increment",
},
{
	.name = "inst_retired",
	.event = "event=0x8",
	.desc = "Instruction retired",
	.topic = "instruction",
	.long_desc = "Instruction architecturally executed",
},
{
	.name = "cid_write_retired",
	.event = "event=0xb",
	.desc = "Write to CONTEXTIDR",
	.topic = "instruction",
	.long_desc = "Instruction architecturally executed, condition code check pass, write to CONTEXTIDR",
},
{
	.name = "inst_spec",
	.event = "event=0x1b",
	.desc = "Speculatively executed",
	.topic = "instruction",
	.long_desc = "Operation speculatively executed",
},
{
	.name = "ttbr_write_retired",
	.event = "event=0x1c",
	.desc = "Instruction executed, TTBR write",
	.topic = "instruction",
	.long_desc = "Instruction architecturally executed (condition check pass), write to TTBR",
},
{
	.name = "br_retired",
	.event = "event=0x21",
	.desc = "Branch retired",
	.topic = "instruction",
	.long_desc = "Instruction architecturally executed, branch. This event counts all branches, taken or not. This excludes exception entries, debug entries and CCFAIL branches",
},
{
	.name = "br_mispred_retired",
	.event = "event=0x22",
	.desc = "Mispredicted branch retired",
	.topic = "instruction",
	.long_desc = "Instruction architecturally executed, mispredicted branch. This event counts any branch counted by BR_RETIRED which is not correctly predicted and causes a pipeline flush",
},
{
	.name = "nop_spec",
	.event = "event=0x100",
	.desc = "Speculatively executed, NOP",
	.topic = "instruction",
	.long_desc = "Operation speculatively executed, NOP",
},
{
	.name = "mem_access_rd",
	.event = "event=0x66",
	.desc = "Data memory access, read",
	.topic = "memory",
	.long_desc = "Data memory access, read",
},
{
	.name = "mem_access_wr",
	.event = "event=0x67",
	.desc = "Data memory access, write",
	.topic = "memory",
	.long_desc = "Data memory access, write",
},
{
	.name = "unaligned_ld_spec",
	.event = "event=0x68",
	.desc = "Unaligned access, read",
	.topic = "memory",
	.long_desc = "Unaligned access, read",
},
{
	.name = "unaligned_st_spec",
	.event = "event=0x69",
	.desc = "Unaligned access, write",
	.topic = "memory",
	.long_desc = "Unaligned access, write",
},
{
	.name = "unaligned_ldst_spec",
	.event = "event=0x6a",
	.desc = "Unaligned access",
	.topic = "memory",
	.long_desc = "Unaligned access",
},
{
	.name = "mem_access",
	.event = "event=0x13",
	.desc = "Memory access",
	.topic = "memory",
	.long_desc = "Data memory access",
},
{
	.name = "mem_error",
	.event = "event=0x1a",
	.desc = "Memory error",
	.topic = "memory",
	.long_desc = "Local memory error. This event counts any correctable or uncorrectable memory error (ECC or parity) in the protected core RAMs",
},
{
	.name = "br_immed_spec",
	.event = "event=0x78",
	.desc = "Branch speculatively executed, immediate branch",
	.topic = "branch",
	.long_desc = "Branch speculatively executed, immediate branch",
},
{
	.name = "br_return_spec",
	.event = "event=0x79",
	.desc = "Branch speculatively executed, procedure return",
	.topic = "branch",
	.long_desc = "Branch speculatively executed, procedure return",
},
{
	.name = "br_indirect_spec",
	.event = "event=0x7a",
	.desc = "Branch speculatively executed, indirect branch",
	.topic = "branch",
	.long_desc = "Branch speculatively executed, indirect branch",
},
{
	.name = "br_mis_pred",
	.event = "event=0x10",
	.desc = "Branch mispredicted",
	.topic = "branch",
	.long_desc = "Mispredicted or not predicted branch speculatively executed",
},
{
	.name = "br_pred",
	.event = "event=0x12",
	.desc = "Predictable branch",
	.topic = "branch",
	.long_desc = "Predictable branch speculatively executed",
},
{
	.name = 0,
	.event = 0,
	.desc = 0,
},
};
struct pmu_event pme_arm_cortex_a53[] = {
{
	.name = "prefetch_linefill",
	.event = "event=0xc2",
	.desc = "Linefill because of prefetch",
	.topic = "cache",
},
{
	.name = "prefetch_linefill_drop",
	.event = "event=0xc3",
	.desc = "Instruction Cache Throttle occurred",
	.topic = "cache",
},
{
	.name = "read_alloc_enter",
	.event = "event=0xc4",
	.desc = "Entering read allocate mode",
	.topic = "cache",
},
{
	.name = "read_alloc",
	.event = "event=0xc5",
	.desc = "Read allocate mode",
	.topic = "cache",
},
{
	.name = "ext_snoop",
	.event = "event=0xc8",
	.desc = "SCU Snooped data from another CPU for this CPU",
	.topic = "cache",
},
{
	.name = "stall_sb_full",
	.event = "event=0xc7",
	.desc = "Data Write operation that stalls the pipeline because the store buffer is full",
	.topic = "pipeline",
},
{
	.name = "other_iq_dep_stall",
	.event = "event=0xe0",
	.desc = "Cycles that the DPU IQ is empty and that is not because of a recent micro-TLB miss, instruction cache miss or pre-decode error",
	.topic = "pipeline",
},
{
	.name = "ic_dep_stall",
	.event = "event=0xe1",
	.desc = "Cycles the DPU IQ is empty and there is an instruction cache miss being processed",
	.topic = "pipeline",
},
{
	.name = "iutlb_dep_stall",
	.event = "event=0xe2",
	.desc = "Cycles the DPU IQ is empty and there is an instruction micro-TLB miss being processed",
	.topic = "pipeline",
},
{
	.name = "decode_dep_stall",
	.event = "event=0xe3",
	.desc = "Cycles the DPU IQ is empty and there is a pre-decode error being processed",
	.topic = "pipeline",
},
{
	.name = "other_interlock_stall",
	.event = "event=0xe4",
	.desc = "Cycles there is an interlock other than  Advanced SIMD/Floating-point instructions or load/store instruction",
	.topic = "pipeline",
},
{
	.name = "agu_dep_stall",
	.event = "event=0xe5",
	.desc = "Cycles there is an interlock for a load/store instruction waiting for data to calculate the address in the AGU",
	.topic = "pipeline",
},
{
	.name = "simd_dep_stall",
	.event = "event=0xe6",
	.desc = "Cycles there is an interlock for an Advanced SIMD/Floating-point operation",
	.topic = "pipeline",
},
{
	.name = "ld_dep_stall",
	.event = "event=0xe7",
	.desc = "Cycles there is a stall in the Wr stage because of a load miss",
	.topic = "pipeline",
},
{
	.name = "st_dep_stall",
	.event = "event=0xe8",
	.desc = "Cycles there is a stall in the Wr stage because of a store",
	.topic = "pipeline",
},
{
	.name = "bus_access_rd",
	.event = "event=0x60",
	.desc = "Bus access read",
	.topic = "bus",
	.long_desc = "Bus access read",
},
{
	.name = "bus_access_wr",
	.event = "event=0x61",
	.desc = "Bus access write",
	.topic = "bus",
	.long_desc = "Bus access write",
},
{
	.name = "exc_irq",
	.event = "event=0x86",
	.desc = "Exception taken, IRQ",
	.topic = "other",
	.long_desc = "Exception taken, IRQ",
},
{
	.name = "exc_fiq",
	.event = "event=0x87",
	.desc = "Exception taken, FIQ",
	.topic = "other",
	.long_desc = "Exception taken, FIQ",
},
{
	.name = "pre_decode_err",
	.event = "event=0xc6",
	.desc = "Pre-decode error",
	.topic = "other",
},
{
	.name = "l1i_cache_err",
	.event = "event=0xd0",
	.desc = "L1 Instruction Cache (data or tag) memory error",
	.topic = "other",
},
{
	.name = "l1d_cache_err",
	.event = "event=0xd1",
	.desc = "L1 Data Cache (data, tag or dirty) memory error, correctable or non-correctable",
	.topic = "other",
},
{
	.name = "tlb_err",
	.event = "event=0xd2",
	.desc = "TLB memory error",
	.topic = "other",
},
{
	.name = "ext_mem_req",
	.event = "event=0xc0",
	.desc = "External memory request",
	.topic = "memory",
},
{
	.name = "ext_mem_req_nc",
	.event = "event=0xc1",
	.desc = "Non-cacheable external memory request",
	.topic = "memory",
},
{
	.name = "br_indirect_spec",
	.event = "event=0x7a",
	.desc = "Branch speculatively executed, indirect branch",
	.topic = "branch",
	.long_desc = "Branch speculatively executed, indirect branch",
},
{
	.name = "br_cond",
	.event = "event=0xc9",
	.desc = "Conditional branch executed",
	.topic = "branch",
},
{
	.name = "br_indirect_mispred",
	.event = "event=0xca",
	.desc = "Indirect branch mispredicted",
	.topic = "branch",
},
{
	.name = "br_indirect_mispred_addr",
	.event = "event=0xcb",
	.desc = "Indirect branch mispredicted because of address miscompare",
	.topic = "branch",
},
{
	.name = "br_cond_mispred",
	.event = "event=0xcc",
	.desc = "Conditional branch mispredicted",
	.topic = "branch",
},
{
	.name = 0,
	.event = 0,
	.desc = 0,
},
};
struct pmu_event pme_hisilicon_hip08[] = {
{
	.name = "l1d_cache_rd",
	.event = "event=0x40",
	.desc = "L1D cache access, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache access, read",
},
{
	.name = "l1d_cache_wr",
	.event = "event=0x41",
	.desc = "L1D cache access, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache access, write",
},
{
	.name = "l1d_cache_refill_rd",
	.event = "event=0x42",
	.desc = "L1D cache refill, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache refill, read",
},
{
	.name = "l1d_cache_refill_wr",
	.event = "event=0x43",
	.desc = "L1D cache refill, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache refill, write",
},
{
	.name = "l1d_cache_wb_victim",
	.event = "event=0x46",
	.desc = "L1D cache Write-Back, victim",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache Write-Back, victim",
},
{
	.name = "l1d_cache_wb_clean",
	.event = "event=0x47",
	.desc = "L1D cache Write-Back, cleaning and coherency",
	.topic = "core imp def",
	.long_desc = "Level 1 data cache Write-Back, cleaning and coherency",
},
{
	.name = "l1d_cache_inval",
	.event = "event=0x48",
	.desc = "L1D cache invalidate",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data cache invalidate",
},
{
	.name = "l1d_tlb_refill_rd",
	.event = "event=0x4c",
	.desc = "L1D tlb refill, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data TLB refill, read",
},
{
	.name = "l1d_tlb_refill_wr",
	.event = "event=0x4d",
	.desc = "L1D tlb refill, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data TLB refill, write",
},
{
	.name = "l1d_tlb_rd",
	.event = "event=0x4e",
	.desc = "L1D tlb access, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data or unified TLB access, read",
},
{
	.name = "l1d_tlb_wr",
	.event = "event=0x4f",
	.desc = "L1D tlb access, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 1 data or unified TLB access, write",
},
{
	.name = "l2d_cache_rd",
	.event = "event=0x50",
	.desc = "L2D cache access, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data cache access, read",
},
{
	.name = "l2d_cache_wr",
	.event = "event=0x51",
	.desc = "L2D cache access, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data cache access, write",
},
{
	.name = "l2d_cache_refill_rd",
	.event = "event=0x52",
	.desc = "L2D cache refill, read",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data cache refill, read",
},
{
	.name = "l2d_cache_refill_wr",
	.event = "event=0x53",
	.desc = "L2D cache refill, write",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data cache refill, write",
},
{
	.name = "l2d_cache_wb_victim",
	.event = "event=0x56",
	.desc = "L2D cache Write-Back, victim",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data cache Write-Back, victim",
},
{
	.name = "l2d_cache_wb_clean",
	.event = "event=0x57",
	.desc = "L2D cache Write-Back, cleaning and coherency",
	.topic = "core imp def",
	.long_desc = "Level 2 data cache Write-Back, cleaning and coherency",
},
{
	.name = "l2d_cache_inval",
	.event = "event=0x58",
	.desc = "L2D cache invalidate",
	.topic = "core imp def",
	.long_desc = "Attributable Level 2 data cache invalidate",
},
{
	.name = "l1i_cache_prf",
	.event = "event=0x102e",
	.desc = "L1I cache prefetch access count",
	.topic = "core imp def",
	.long_desc = "Level 1 instruction cache prefetch access count",
},
{
	.name = "l1i_cache_prf_refill",
	.event = "event=0x102f",
	.desc = "L1I cache miss due to prefetch access count",
	.topic = "core imp def",
	.long_desc = "Level 1 instruction cache miss due to prefetch access count",
},
{
	.name = "iq_is_empty",
	.event = "event=0x1043",
	.desc = "Instruction queue is empty",
	.topic = "core imp def",
	.long_desc = "Instruction queue is empty",
},
{
	.name = "if_is_stall",
	.event = "event=0x1044",
	.desc = "Instruction fetch stall cycles",
	.topic = "core imp def",
	.long_desc = "Instruction fetch stall cycles",
},
{
	.name = "fetch_bubble",
	.event = "event=0x2014",
	.desc = "Instructions can receive, but not send",
	.topic = "core imp def",
	.long_desc = "Instructions can receive, but not send",
},
{
	.name = "prf_req",
	.event = "event=0x6013",
	.desc = "Prefetch request from LSU",
	.topic = "core imp def",
	.long_desc = "Prefetch request from LSU",
},
{
	.name = "hit_on_prf",
	.event = "event=0x6014",
	.desc = "Hit on prefetched data",
	.topic = "core imp def",
	.long_desc = "Hit on prefetched data",
},
{
	.name = "exe_stall_cycle",
	.event = "event=0x7001",
	.desc = "Cycles of that the number of issue ups are less than 4",
	.topic = "core imp def",
	.long_desc = "Cycles of that the number of issuing micro operations are less than 4",
},
{
	.name = "mem_stall_anyload",
	.event = "event=0x7004",
	.desc = "No any micro operation is issued and meanwhile any load operation is not resolved",
	.topic = "core imp def",
	.long_desc = "No any micro operation is issued and meanwhile any load operation is not resolved",
},
{
	.name = "mem_stall_l1miss",
	.event = "event=0x7006",
	.desc = "No any micro operation is issued and meanwhile there is any load operation missing L1 cache and pending data refill",
	.topic = "core imp def",
	.long_desc = "No any micro operation is issued and meanwhile there is any load operation missing L1 cache and pending data refill",
},
{
	.name = "mem_stall_l2miss",
	.event = "event=0x7007",
	.desc = "No any micro operation is issued and meanwhile there is any load operation missing both L1 and L2 cache and pending data refill from L3 cache",
	.topic = "core imp def",
	.long_desc = "No any micro operation is issued and meanwhile there is any load operation missing both L1 and L2 cache and pending data refill from L3 cache",
},
{
	.name = 0,
	.event = 0,
	.desc = 0,
},
};
struct pmu_events_map pmu_events_map[] = {
{
	.cpuid = "0x00000000410fd03[[:xdigit:]]",
	.version = "v1",
	.type = "core",
	.table = pme_arm_cortex_a53
},
{
	.cpuid = "0x00000000420f5160",
	.version = "v1",
	.type = "core",
	.table = pme_cavium_thunderx2
},
{
	.cpuid = "0x00000000430f0af0",
	.version = "v1",
	.type = "core",
	.table = pme_cavium_thunderx2
},
{
	.cpuid = "0x00000000480fd010",
	.version = "v1",
	.type = "core",
	.table = pme_hisilicon_hip08
},
{
	.cpuid = "0x00000000500f0000",
	.version = "v1",
	.type = "core",
	.table = pme_ampere_emag
},
{
	.cpuid = 0,
	.version = 0,
	.type = 0,
	.table = 0,
},
};
